Package com.treemap.treeplot

# Class Spoint

java.lang.Object
com.treemap.treeplot.Spoint

public final class Spoint extends Object

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `Spoint`
  `chnext`
  `Spoint`
  `chprev`
  `Spoint`
  `next`
  `Spoint`
  `prev`
  `final double`
  `x`
  `final double`
  `y`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Spoint(double inx, double iny)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Spoint`
  `add(Spoint other)`
  `void`
  `AddClosest(Spoint who, long col)`
  `void`
  `AddSpheresLink(Spoint who)`
  `void`
  `AddSpheresLink(Spoint who, long col)`
  `static double`
  `angleBetweenPoints(Spoint a, Spoint b, Spoint c)`
  `Spoint`
  `Average(Spoint other)`
  `Spoint`
  `Delete()`
  `double`
  `distance(Spoint other)`
  `static Spoint`
  `infiniteLineIntersection(Spoint base1, Spoint v1, Spoint base2, Spoint v2)`
  `boolean`
  `Insert(Spoint who)`
  `Spoint`
  `Negate()`
  `void`
  `NNDelete()`
  `Spoint`
  `Normalize()`
  `Spoint`
  `normalLeft()`
  `Spoint`
  `NormalRight()`
  `static Spoint`
  `Polar2Vect(double r, double theta)`
  `Spoint`
  `scale(double byWhat)`
  `Spoint`
  `subtract(Spoint other)`
  `String`
  `toString()`
  `Spoint`
  `VirtualInsert(Spoint who)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### x

    public final double x

  - ### y

    public final double y

  - ### next

    public Spoint next

  - ### prev

    public Spoint prev

  - ### chnext

    public Spoint chnext

  - ### chprev

    public Spoint chprev

- ## Constructor Details

  - ### Spoint

    public Spoint(double inx, double iny)

- ## Method Details

  - ### Insert

    public boolean Insert(Spoint who)

  - ### VirtualInsert

    public Spoint VirtualInsert(Spoint who)

  - ### Delete

    public Spoint Delete()

  - ### AddClosest

    public void AddClosest(Spoint who, long col)

  - ### NNDelete

    public void NNDelete()

  - ### AddSpheresLink

    public void AddSpheresLink(Spoint who, long col)

  - ### AddSpheresLink

    public void AddSpheresLink(Spoint who)

  - ### distance

    public double distance(Spoint other)

  - ### add

    public Spoint add(Spoint other)

  - ### subtract

    public Spoint subtract(Spoint other)

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### scale

    public Spoint scale(double byWhat)

  - ### NormalRight

    public Spoint NormalRight()

  - ### normalLeft

    public Spoint normalLeft()

  - ### Normalize

    public Spoint Normalize()

  - ### Average

    public Spoint Average(Spoint other)

  - ### Negate

    public Spoint Negate()

  - ### infiniteLineIntersection

    public static Spoint infiniteLineIntersection(Spoint base1, Spoint v1, Spoint base2, Spoint v2)

  - ### Polar2Vect

    public static Spoint Polar2Vect(double r, double theta)

  - ### angleBetweenPoints

    public static double angleBetweenPoints(Spoint a, Spoint b, Spoint c)